; Apocalypse Now
;  by matthew@iosa.com
;  12-May-98

hirambase       =       0ff80h
lorambase       =       0c0a0h

#DEFINE LOBYTEVAR(X)  X = lorambase \lorambase  .set (lorambase + 1)
#DEFINE HIBYTEVAR(X)  X = hirambase \hirambase  .set (hirambase + 1)
#DEFINE LOWORDVAR(X)  X = lorambase \lorambase  .set (lorambase + 2)
#DEFINE HIWORDVAR(X)  X = hirambase \hirambase  .set (hirambase + 2)
; Create variables in low-ram

LOBYTEVAR(xpos)                 ; background X-Position
LOBYTEVAR(spry)                 ;
LOBYTEVAR(sprx)                 ;
LOBYTEVAR(spry2)                ;
LOBYTEVAR(sprx2)                ;


.org $0000              ; start of binary

.org $0040              ; VBlank IRQ
 jp $ff80               ; Update sprites   <<<vblank sprite updates
.org $0048              ; LCDC Status IRQ
 reti                   ; Do nothing
.org $0050              ; Timer Owerflow
 reti                   ; Do nothing
.org $0058              ; Serial Transfear Completion
 reti                   ; Do nothing
.org $0060              ; Hmm, this is a wierd on
                        ; Im not sure how this one works
                        ; Transition from high to low
                        ; of pin p10-p13
                        ; I think Its a hardware thing
 reti                   ; Do nothing :)
; Irqs done..

.org $0100
 nop
 jp $150

; GameBoy Header with correct checksum
.db $CE,$ED,$66,$66,$CC,$0D,$00,$0B,$03,$73,$00,$83       ;<<< no $00,$c3,$50,$01
.db $00,$0C,$00,$0D,$00,$08,$11,$1F,$88,$89,$00,$0E,$DC,$CC,$6E,$E6
.db $DD,$DD,$D9,$99,$BB,$BB,$67,$63,$6E,$0E,$EC,$CC,$DD,$DC,$99,$9F
.db $BB,$B9,$33,$3E     ; Standard Nintendo DO NOT CHANGE...

.db "APOCALYPSE NOW  "  ; Cart name   16bytes
.db $00,$00,$00         ; Not used
.db $00                 ; Cart type   ROM Only
.db $00                 ; ROM Size    32k
.db $00                 ; RAM Size     0k
.db $cf,$08             ; Maker ID Matthew Johnson
.db $01                 ; Version     =1
.db $DA                 ; Complement check (Important)
.db $ff,$ff             ; Cheksum, fix this if you are going to
                        ; run this in VGB, or simpy use the -NOCRC
                        ; switch in the VGB-DOS command line.
.org $150
start                   ; This is addr $0150
 ld     sp,$fff4        ; Put the stack where the GB wants it
 ld     a,%00000001     ; No IRQs but VBlank   <<<vblank interrupt on
 ldh    ($ff),a
 call initdma
 ei                     ; <<< enable interrupts after initdma
 sub    a               ; Misc standard init things..
 ldh    ($41),a         ; LCDC Status
 ldh    ($42),a         ; Screen scroll Y=0
 ldh    ($43),a         ; Screen scroll X=0

 ld     a,%00000000     ; LCD Controller = Off (No picture on screen)
                        ; WindowBank = $9800 (Not used)
                        ; Window = OFF
                        ; BG Chr = $8000
                        ; BG Bank= $9800
                        ; Sprites= 8x8 (Size Assembly, 1=8x16)
                        ; Sprites= Off (Sprites on or off)
                        ; BG     = Off
 ldh    ($40),a

setup

 ld    bc,chrset
 call   mchar
 ld    bc,chrmap
 call   map
 call  nor_col
 call   spr_cls
 ld     a,%10010111     ; LCD Controller = On
                        ; WindowBank = $9800 (Not used)
                        ; Window = OFF
                        ; BG Chr = $8000
                        ; BG Bank= $9800
                        ; Sprites= 8x16 (Size Assembly, 0=8x8)
                        ; Sprites= On
                        ; BG     = On
 ldh    ($40),a

sprsetup
 push af                ;save af
 ld a,80                ;y position of sprite one
 ld (spry),a            ;save y
 ld ($c000),a           ;sprite 1's y address
 ld a,76                ;x position of sprite one
 ld (sprx),a            ;save x
 ld ($c001),a           ;sprite 1's x address
 ld a,$24               ;sprite tile 24 + 25
 ld ($c002),a           ;sprite 1's tile address
 ld a,%00000000         ;set flags
 ld ($c003),a           ;save flags

 ld a,80                ;y position of sprite two
 ld (spry2),a           ;save y
 ld ($c004),a           ;sprite 2's y address
 ld a,84                ;x position of sprite two
 ld (sprx2),a           ;save x
 ld ($c005),a           ;sprite 2's x address
 ld a,$26               ;sprite tile 26 + 27
 ld ($c006),a           ;sprite 2's tile address
 ld a,%00000000         ;set flags
 ld ($c007),a           ;save flags
 pop af                 ;restore a
; call $ff80            ;<<< no longer needed - vblank interrupt updates sprites

main                    ;game
 call getkeys
 bit $0,a               ;right?
 call nz,right
 bit $1,a
 call nz,left           ;left?
 bit $2,a
 call nz,down           ;down?
 bit $3,a
 call nz, up            ;up?
 call scroll_right      ;scroll screen
; call $ff80            ;<<< no longer needed - vblank interrupt updates sprites
  jr main               ;loop


nor_col                 ; Sets the colors to normal palette
 ld     a,%11100100     ; grey 3=11 (Black)
                        ; grey 2=10 (Dark grey)
                        ; grey 1=01 (Ligth grey)
                        ; grey 0=00 (Transparent)
 ldh    ($47),a
 ldh    ($48),a         ; 48,49 are sprite palettes
                        ; set same as background
 ldh    ($49),a
 ret

mchar
 ld     hl,$8000
 ld     d,$00           ; move 256 bytes
 ld     e,$12           ; x2=512. Increase this value
                        ; to copy more of the character set.
mchar_loop
 ldh     a,($41)        ; There are only certain times you
 and     2              ; can write out scrn/tile.  This
 jr nz,mchar_loop       ; loop waits for those times.
 ld     a,(bc)
 ld     (hli),a
 inc    bc
 dec    d
 jp     nz,mchar_loop
 dec    e
 jp     nz,mchar_loop
 ret

map
 ld     hl,$9800
 ld     d,$00
 ld     e,$04           ; 256*4=1024=32x32=One whole GB Screen
map_loop
 ldh     a,($41)
 and     2
 jr nz,map_loop
 ld     a,(bc)
 ld     (hli),a
 inc    bc
 dec    d
 jp     nz,map_loop
 dec    e
 jp     nz,map_loop
 ret

spr_cls                 ; Clear Sprites
 ld l,0
 ld h,$c0              ;<<< was $ce
spclear
 ld a,$ff
 ld (hl),a
 inc l
 ld a,l
 cp $ff
 jp nz,spclear
 ret

delay                   ;delay (scroll)
 dec hl
 ld a,h
 or l
 jr nz,delay
 ret

getkeys                 ;gets keypress
 ld a,$20
 ldh ($00),a
 ldh a,($00)
 ldh a,($00)

 cpl
 and $0f
 swap a
 ld b,a

 ld a,$10
 ldh ($00),a
 ldh a,($00)
 ldh a,($00)
 ldh a,($00)
 ldh a,($00)
 ldh a,($00)
 ldh a,($00)

 cpl
 and $0f
 or b
 swap a
 ret

right                   ;move sprites right(scope)
 push af                ;by incrementing the x byte
 ld a,(sprx)
 inc a
 ld (sprx),a
 ld ($c001),a

 ld a,(sprx2)           ;same as about but moves second
 inc a                  ;sprite's x (other half of the scope)
 ld (sprx2),a
 ld ($c005),a
 pop af
 ret

left                    ;oppesite of above
 push af
 ld a,(sprx)
 dec a
 ld (sprx),a
 ld ($c001),a

 ld a,(sprx2)
 dec a
 ld (sprx2),a
 ld ($c005),a
 pop af
 ret

up
 push af                ;moves by incrementing the sprites y
 ld a,(spry)            ;byte
 inc a
 ld (spry),a
 ld ($c000),a

 ld a,(spry2)
 inc a
 ld (spry2),a
 ld ($c004),a
 pop af
 ret

down
 push af                ;oppesite of above
 ld a,(spry)
 dec a
 ld (spry),a
 ld ($c000),a

 ld a,(spry2)
 dec a
 ld (spry2),a
 ld ($c004),a
 pop af
 ret

scroll_right            ;scrolls screen
 push af                ;by increment the ff43 register
 ld a,(xpos)            ;and then saving it
 inc a
 ld (xpos),a
 ldh ($43),a
 pop af
 ld hl,$1eff            ;length to delay
 call delay             ;delay!
 ret

initdma                 ; Transfer DMA routine to RAM
 ld     de,$ff80
 ld     hl,dmacode
 ld     bc,dmaend-dmacode
 call   move
 ret

dmacode                 ; Transfer sprite data from reg A pos. using DMA
 push af
 ld     a,$c0           ; <<< Set DMA from address to $c000
 ldh    ($46),a         ; Start DMA
 ld     a,$28           ; Wait for 160ns
dma_wait
 dec    a
 jr     nz,dma_wait
 pop af
 reti
dmaend

move
 ldh     a,(41h)
 and     2
 jr      nz,move
 ld     a,(hli)
 ld     (de),a
 inc    de
 dec    bc
 ld     a,b             ; Are we done (is bc=0000??)
 or     c
 jr     nz, move
 ret

chrset:
#include "chr.tsm"      ;my tiles

chrmap:
#include "map.tsm"      ;my map

.block $008000-$
.end start


